import { ILifecycleService, LifecyclePhase, WillShutdownEvent, StartupKind, BeforeShutdownEvent, ShutdownReason } from '@workbench-stack/core';
import { Event } from '@vscode/monaco-editor/esm/vs/base/common/event';
export declare class LifecycleService implements ILifecycleService {
    protected logService: any;
    startupKind: StartupKind;
    private _phase;
    private phaseWhen;
    private _onBeforeShutdown;
    private _onWillShutdown;
    private _onShutdown;
    constructor(logService: any);
    phase: LifecyclePhase;
    fireShutdown(reason?: ShutdownReason): void;
    fireWillShutdown(event: BeforeShutdownEvent): void;
    readonly onBeforeShutdown: Event<BeforeShutdownEvent>;
    readonly onWillShutdown: Event<WillShutdownEvent>;
    readonly onShutdown: Event<void>;
    when(phase: LifecyclePhase): Promise<void>;
}
